/*
 *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
*****************************************************************************/
'use strict';Object.defineProperty(exports,"__esModule",{value:!0});var React=require("react"),isUndefined=a=>void 0===a,isNullOrUndefined=a=>null===a||isUndefined(a),isArray=a=>Array.isArray(a);let isObjectType=a=>"object"===typeof a;var isObject=a=>!isNullOrUndefined(a)&&!isArray(a)&&isObjectType(a),isHTMLElement=a=>isObject(a)&&a.nodeType===Node.ELEMENT_NODE;
let VALIDATION_MODE={onBlur:"onBlur",onChange:"onChange",onSubmit:"onSubmit"},VALUE="value",UNDEFINED="undefined",EVENTS={BLUR:"blur",CHANGE:"change",INPUT:"input"},INPUT_VALIDATION_RULES={max:"max",min:"min",maxLength:"maxLength",minLength:"minLength",pattern:"pattern",required:"required",validate:"validate"},REGEX_IS_DEEP_PROP=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,REGEX_IS_PLAIN_PROP=/^\w*$/,REGEX_PROP_NAME=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g,
REGEX_ESCAPE_CHAR=/\\(\\)?/g,REGEX_ARRAY_FIELD_INDEX=/[\d+]/g;function attachEventListeners({field:{ref:a},handleChange:b,isRadioOrCheckbox:c}){isHTMLElement(a)&&b&&(a.addEventListener(c?EVENTS.CHANGE:EVENTS.INPUT,b),a.addEventListener(EVENTS.BLUR,b))}var isKey=a=>!isArray(a)&&(REGEX_IS_PLAIN_PROP.test(a)||!REGEX_IS_DEEP_PROP.test(a)),stringToPath=a=>{let b=[];a.replace(REGEX_PROP_NAME,(a,d,e,f)=>{b.push(e?f.replace(REGEX_ESCAPE_CHAR,"$1"):d||a)});return b};
function set(a,b,c){let d=-1;b=isKey(b)?[b]:stringToPath(b);let e=b.length,f=e-1;for(;++d<e;){let e=b[d];var g=c;d!==f&&(g=a[e],g=isObject(g)||isArray(g)?g:isNaN(+b[d+1])?{}:[]);a[e]=g;a=a[e]}return a}
var transformToNestObject=a=>Object.entries(a).reduce((a,[c,d])=>isKey(c)?Object.assign(Object.assign({},a),{[c]:d}):(set(a,c,d),a),{}),get=(a,b,c)=>{let d=b.split(/[,[\].]+?/).filter(Boolean).reduce((a,b)=>isNullOrUndefined(a)?a:a[b],a);return isUndefined(d)||d===a?a[b]||c:d},focusErrorField=(a,b)=>{for(let c in a)if(get(b,c)){let b=a[c];if(b)if(b.ref.focus){b.ref.focus();break}else if(b.options){b.options[0].ref.focus();break}}},removeAllEventListeners=(a,b)=>{isHTMLElement(a)&&a.removeEventListener&&
(a.removeEventListener(EVENTS.INPUT,b),a.removeEventListener(EVENTS.CHANGE,b),a.removeEventListener(EVENTS.BLUR,b))},isRadioInput=a=>"radio"===a.type,isCheckBoxInput=a=>"checkbox"===a.type;function isDetached(a){return a?a instanceof HTMLElement&&a.nodeType!==Node.DOCUMENT_NODE?isDetached(a.parentNode):!1:!0}var isEmptyObject=a=>isObject(a)&&!Object.keys(a).length;function castPath(a){return isArray(a)?a:stringToPath(a)}
function baseGet(a,b){let c=isKey(b)?[b]:castPath(b);b=b.length;let d=0;for(;d<b;)a=isUndefined(a)?d++:a[c[d++]];return d==b?a:void 0}function baseSlice(a,b,c){let d=-1,e=a.length;0>b&&(b=-b>e?0:e+b);c=c>e?e:c;0>c&&(c+=e);e=b>c?0:c-b;for(c=Array(e);++d<e;)c[d]=a[d+b];return c}function parent(a,b){return 1==b.length?a:baseGet(a,baseSlice(b,0,-1))}
function baseUnset(a,b){b=isKey(b)?[b]:castPath(b);var c=parent(a,b),d=b[b.length-1];c=null==c||delete c[d];d=void 0;for(let c=0;c<b.slice(0,-1).length;c++){let e=-1,g=void 0,l=b.slice(0,-(c+1)),x=l.length-1;for(0<c&&(d=a);++e<l.length;){let b=l[e];g=g?g[b]:a[b];x===e&&(isObject(g)&&isEmptyObject(g)||isArray(g)&&!g.filter(a=>isObject(a)&&!isEmptyObject(a)).length)&&(d?delete d[b]:delete a[b]);d=g}}return c}function unset(a,b){b.forEach(b=>{baseUnset(a,b)});return a}
function findRemovedFieldAndRemoveListener(a,b,c,d){let {ref:e,ref:{name:f,type:g},mutationWatcher:l}=c;if(g)if(c=a[f],(isRadioInput(e)||isCheckBoxInput(e))&&c){let {options:e}=c;isArray(e)&&e.length?(e.filter(Boolean).forEach(({ref:a,mutationWatcher:c},f)=>{if(a&&isDetached(a)||d)removeAllEventListeners(a,b),c&&c.disconnect(),unset(e,[`[${f}]`])}),e&&!e.filter(Boolean).length&&delete a[f]):delete a[f]}else{if(isDetached(e)||d)removeAllEventListeners(e,b),l&&l.disconnect(),delete a[f]}else delete a[f]}
let defaultReturn={isValid:!1,value:""};var getRadioValue=a=>isArray(a)?a.filter(Boolean).reduce((a,{ref:{checked:c,value:d}})=>c?{isValid:!0,value:d}:a,defaultReturn):defaultReturn,getMultipleSelectValue=a=>[...a].filter(({selected:a})=>a).map(({value:a})=>a),isFileInput=a=>"file"===a.type,isMultipleSelect=a=>"select-multiple"===a.type,isEmptyString=a=>""===a;let defaultResult={value:!1,isValid:!1},validResult={value:!0,isValid:!0};
var getCheckboxValue=a=>{if(isArray(a)){if(1<a.length)return a=a.filter(({ref:{checked:a}})=>a).map(({ref:{value:a}})=>a),{value:a,isValid:!!a.length};let {checked:b,value:c,attributes:d}=a[0].ref;return b?d&&!isUndefined(d.value)?isUndefined(c)||isEmptyString(c)?validResult:{value:c,isValid:!0}:validResult:defaultResult}return defaultResult};
function getFieldValue(a,b){let {name:c,value:d}=b;a=a[c];return isFileInput(b)?b.files:isRadioInput(b)?a?getRadioValue(a.options).value:"":isMultipleSelect(b)?getMultipleSelectValue(b.options):isCheckBoxInput(b)?a?getCheckboxValue(a.options).value:!1:d}
var isString=a=>"string"===typeof a,getFieldsValues=(a,b)=>{let c={};for(let d in a)if(isUndefined(b)||(isString(b)?d.startsWith(b):isArray(b)?b.find(a=>d.startsWith(a)):b&&b.nest))c[d]=getFieldValue(a,a[d].ref);return c},compareObject=(a={},b={})=>{a=Object.entries(a);let c=Object.keys(b);return a.length===c.length&&a.reduce((a,[c,f])=>a?b[c]&&b[c]===f:!1,!0)},isSameError=(a,{type:b,types:c,message:d})=>isObject(a)&&a.type===b&&a.message===d&&compareObject(a.types,c);
function shouldUpdateWithError({errors:a,name:b,error:c,validFields:d,fieldsWithValidation:e}){let f=isEmptyObject(c),g=isEmptyObject(a);c=get(c,b);a=get(a,b);return f&&d.has(b)||a&&a.isManual?!1:g!==f||!g&&!a||f&&e.has(b)&&!d.has(b)?!0:c&&!isSameError(a,c)}var isRegex=a=>a instanceof RegExp,getValueAndMessage=a=>isObject(a)&&!isRegex(a)?a:{value:a,message:""},isFunction=a=>"function"===typeof a,isBoolean=a=>"boolean"===typeof a,isMessage=a=>isString(a)||isObject(a)&&React.isValidElement(a);
function getValidateError(a,b,c="validate"){if(isMessage(a)||isBoolean(a)&&!a)return{type:c,message:isMessage(a)?a:"",ref:b}}
var appendErrors=(a,b,c,d,e)=>b?(a=c[a],Object.assign(Object.assign({},a),{types:Object.assign(Object.assign({},a&&a.types?a.types:{}),{[d]:e||!0})})):{},validateField=async(a,b,{ref:c,ref:{type:d,value:e,name:f},options:g,required:l,maxLength:x,minLength:h,min:z,max:n,pattern:k,validate:r})=>{var D;let p=a.current,m={},A=isRadioInput(c),t=isCheckBoxInput(c);a=A||t;let C=isEmptyString(e),q=appendErrors.bind(null,f,b,m),K=(a,d,e,g=INPUT_VALIDATION_RULES.maxLength,h=INPUT_VALIDATION_RULES.minLength)=>
{d=a?d:e;m[f]=Object.assign({type:a?g:h,message:d,ref:c},a?q(g,d):q(h,d));if(!b)return m};if(l&&(!A&&!t&&(C||isNullOrUndefined(e))||isBoolean(e)&&!e||t&&!getCheckboxValue(g).isValid||A&&!getRadioValue(g).isValid)){let {value:d,message:e}=isMessage(l)?{value:!!l,message:l}:getValueAndMessage(l);if(d&&(m[f]=Object.assign({type:INPUT_VALIDATION_RULES.required,message:e,ref:a?null===(D=p[f].options)||void 0===D?void 0:D[0].ref:c},q(INPUT_VALIDATION_RULES.required,e)),!b))return m}if(!isNullOrUndefined(z)||
!isNullOrUndefined(n)){let a,f,{value:g,message:h}=getValueAndMessage(n),{value:k,message:l}=getValueAndMessage(z);"number"===d||!d&&!isNaN(e)?(d=c.valueAsNumber||parseFloat(e),isNullOrUndefined(g)||(a=d>g),isNullOrUndefined(k)||(f=d<k)):(d=c.valueAsDate||new Date(e),isString(g)&&(a=d>new Date(g)),isString(k)&&(f=d<new Date(k)));if(a||f)if(K(!!a,h,l,INPUT_VALIDATION_RULES.max,INPUT_VALIDATION_RULES.min),!b)return m}if(isString(e)&&!C&&(x||h)){let {value:a,message:c}=getValueAndMessage(x),{value:d,
message:f}=getValueAndMessage(h);h=e.toString().length;x=!isNullOrUndefined(a)&&h>a;h=!isNullOrUndefined(d)&&h<d;if(x||h)if(K(!!x,c,f),!b)return m}if(k&&!C){let {value:a,message:d}=getValueAndMessage(k);if(isRegex(a)&&!a.test(e)&&(m[f]=Object.assign({type:INPUT_VALIDATION_RULES.pattern,message:d,ref:c},q(INPUT_VALIDATION_RULES.pattern,d)),!b))return m}if(r)if(e=getFieldValue(p,c),g=a&&g?g[0].ref:c,isFunction(r))r=await r(e),(r=getValidateError(r,g))&&(m[f]=Object.assign(Object.assign({},r),q(INPUT_VALIDATION_RULES.validate,
r.message)));else if(isObject(r)){k={};for(let [a,c]of Object.entries(r)){if(!isEmptyObject(k)&&!b)break;r=await c(e);if(r=getValidateError(r,g,a))k=Object.assign(Object.assign({},r),q(a,r.message)),b&&(m[f]=k)}isEmptyObject(k)||(m[f]=Object.assign({ref:g},k))}return m};
let parseErrorSchema=(a,b)=>isArray(a.inner)?a.inner.reduce((a,{path:d,message:e,type:f})=>Object.assign(Object.assign({},a),a[d]&&b?{[d]:appendErrors(d,b,a,f,e)}:{[d]:a[d]||Object.assign({message:e,type:f},b?{types:{[f]:e||!0}}:{})}),{}):{[a.path]:{message:a.message,type:a.type}};
async function validateWithSchema(a,b,c,d,e){if(d)return d(c,e);try{return{values:await a.validate(c,{abortEarly:!1,context:e}),errors:{}}}catch(f){return{values:{},errors:transformToNestObject(parseErrorSchema(f,b))}}}var isPrimitive=a=>isNullOrUndefined(a)||!isObjectType(a);let getPath=(a,b)=>{const c=(b,c,f)=>{c=f?`${a}.${c}`:`${a}[${c}]`;return isPrimitive(b)?c:getPath(c,b)};return isArray(b)?b.map((a,b)=>c(a,b)):Object.entries(b).map(([a,b])=>c(b,a,!0))};
var getPath$1=(a,b)=>getPath(a,b).flat(Infinity),assignWatchFields=(a,b,c,d)=>{c.add(b);isEmptyObject(a)?a=void 0:isUndefined(a[b])?(a=get(transformToNestObject(a),b),isUndefined(a)||getPath$1(b,a).forEach(a=>c.add(a))):(a=a[b],c.add(b));return isUndefined(a)?isObject(d)?get(d,b):d:a},skipValidation=({isOnChange:a,hasError:b,isBlurEvent:c,isOnSubmit:d,isReValidateOnSubmit:e,isOnBlur:f,isReValidateOnBlur:g,isSubmitted:l})=>a&&c||d&&e||d&&!l||f&&!c&&!b||g&&!c&&b||e&&l,getFieldArrayParentName=a=>a.substring(0,
a.indexOf("[")),getFieldValueByName=(a,b)=>{a=transformToNestObject(getFieldsValues(a));return b?get(a,b,a):a};function getIsFieldsDifferent(a,b){let c=!1;if(!isArray(a)||!isArray(b)||a.length!==b.length)return!0;for(let d=0;d<a.length&&!c;d++){let e=a[d],f=b[d];if(isUndefined(f)||Object.keys(e).length!==Object.keys(f).length){c=!0;break}for(let a in e)if(e[a]!==f[a]){c=!0;break}}return c}let isMatchFieldArrayName=(a,b)=>RegExp(`^${b}[\\d+]`.replace(/\[/g,"\\[").replace(/\]/g,"\\]")).test(a);
var isNameInFieldArray=(a,b)=>[...a].reduce((a,d)=>isMatchFieldArrayName(b,d)?!0:a,!1),isFileListObject=a=>typeof FileList!==UNDEFINED&&a instanceof FileList;function onDomRemove(a,b){let c=new MutationObserver(()=>{isDetached(a)&&(c.disconnect(),b())});c.observe(window.document,{childList:!0,subtree:!0});return c}
var modeChecker=a=>({isOnSubmit:!a||a===VALIDATION_MODE.onSubmit,isOnBlur:a===VALIDATION_MODE.onBlur,isOnChange:a===VALIDATION_MODE.onChange}),isRadioOrCheckboxFunction=a=>isRadioInput(a)||isCheckBoxInput(a);let {useRef,useState,useCallback,useEffect}=React;
function useForm({mode:a=VALIDATION_MODE.onSubmit,reValidateMode:b=VALIDATION_MODE.onChange,validationSchema:c,validationResolver:d,validationContext:e,defaultValues:f={},submitFocusError:g=!0,validateCriteriaMode:l}={}){function x(a,b={}){if(!a.name)return console.warn("Missing name @",a);let {name:c,type:w,value:d}=a,e=Object.assign({ref:a},b),V=h.current,u=isRadioOrCheckboxFunction(a),f=V[c],g=!0,k=!1,l;if(u?f&&isArray(f.options)&&f.options.filter(Boolean).find(({ref:a})=>d===a.value):f)V[c]=Object.assign(Object.assign({},
f),b);else{if(w){let d=onDomRemove(a,()=>W(e));f=u?Object.assign({options:[...f&&f.options||[],{ref:a,mutationWatcher:d}],ref:{type:w,name:c}},b):Object.assign(Object.assign({},e),{mutationWatcher:d})}else f=e;V[c]=f;isEmptyObject(q.current)||(l=get(q.current,c),g=isUndefined(l),k=isNameInFieldArray(E.current,c),g||k||T(f,l));F&&!k&&H.current.isValid?X():isEmptyObject(b)||(m.current.add(c),!G&&H.current.isValid&&validateField(h,z,f).then(a=>{let b=t.current;isEmptyObject(a)?A.current.add(c):t.current=
!1;b!==t.current&&y()}));C.current[c]||k&&g||(C.current[c]=g?getFieldValue(V,f.ref):l);w&&attachEventListeners({field:u&&f.options?f.options[f.options.length-1]:f,isRadioOrCheckbox:u,handleChange:v.current})}}let h=useRef({}),z="all"===l,n=useRef({}),k=useRef({}),r=useRef({}),D=useRef(new Set),p=useRef(new Set),m=useRef(new Set),A=useRef(new Set),t=useRef(!0),C=useRef({}),q=useRef(f),K=useRef(!1),M=useRef(!1),B=useRef(!1),N=useRef(!1),Q=useRef(0),O=useRef(!1),v=useRef(),P=useRef({}),I=useRef(e),E=
useRef(new Set),[,R]=useState(),{isOnBlur:J,isOnSubmit:G,isOnChange:S}=useRef(modeChecker(a)).current,u=typeof window===UNDEFINED,F=!(!c&&!d),L=typeof document!==UNDEFINED&&!u&&!isUndefined(window.HTMLElement);a=L&&"Proxy"in window;let H=useRef({dirty:!a,dirtyFields:!a,isSubmitted:G,submitCount:!a,touched:!a,isSubmitting:!a,isValid:!a}),{isOnBlur:da,isOnSubmit:ea}=useRef(modeChecker(b)).current;I.current=e;let y=useCallback(()=>{K.current||R({})},[]),U=useCallback((a,b,c,d)=>{c=c||shouldUpdateWithError({errors:n.current,
error:b,name:a,validFields:A.current,fieldsWithValidation:m.current});if(isEmptyObject(b)){if(m.current.has(a)||F)A.current.add(a),c=c||get(n.current,a);n.current=unset(n.current,[a])}else A.current.delete(a),c=c||!get(n.current,a),set(n.current,a,b[a]);if(c&&!d)return y(),!0},[y,F]),T=useCallback((a,b)=>{const c=a.ref;a=a.options;const {type:d}=c,w=L&&isHTMLElement(c)&&isNullOrUndefined(b)?"":b;isRadioInput(c)&&a?a.forEach(({ref:a})=>a.checked=a.value===w):isFileInput(c)?isFileListObject(w)?c.files=
w:c.value=w:isMultipleSelect(c)?[...c.options].forEach(a=>a.selected=w.includes(a.value)):isCheckBoxInput(c)&&a?1<a.length?a.forEach(({ref:a})=>a.checked=w.includes(a.value)):a[0].ref.checked=!!w:c.value=w;return!!d},[L]),fa=a=>{if(!h.current[a]||!H.current.dirty&&!H.current.dirtyFields)return!1;const b=isNameInFieldArray(E.current,a),c=p.current.size;var d=C.current[a]!==getFieldValue(h.current,h.current[a].ref);b&&(d=getFieldArrayParentName(a),d=getIsFieldsDifferent(getFieldValueByName(h.current,
d),get(q.current,d)));const w=(b?N.current:p.current.has(a))!==d;d?p.current.add(a):p.current.delete(a);N.current=b?d:!!p.current.size;return H.current.dirty?w:c!==p.current.size},Y=useCallback(a=>{if(fa(a)||!get(k.current,a)&&H.current.touched)return!!set(k.current,a,!0)},[]),Z=useCallback((a,b,c)=>{const d=isArray(b);for(const w in b){const e=`${c||a}${d?`[${w}]`:`.${w}`}`;isObject(b[w])&&Z(a,b[w],e);const f=h.current[e];f&&(T(f,b[w]),Y(e))}},[T,Y]),ha=useCallback((a,b)=>{const c=h.current[a];if(c){if(T(c,
b),a=Y(a),isBoolean(a))return a}else isPrimitive(b)||Z(a,b)},[Y,T,Z]),aa=useCallback(async(a,b)=>{var c=h.current[a];if(!c)return!1;c=await validateField(h,z,c);U(a,c,!1,b);return isEmptyObject(c)},[U,z]),ia=useCallback(async a=>{const {errors:b}=await validateWithSchema(c,z,getFieldValueByName(h.current),d,I.current),e=t.current;t.current=isEmptyObject(b);isArray(a)?(a.forEach(a=>{const c=get(b,a);c?set(n.current,a,c):unset(n.current,[a])}),y()):U(a,get(b,a)?{[a]:get(b,a)}:{},e!==t.current);return isEmptyObject(n.current)},
[y,U,z,d,c]),ba=useCallback(async a=>{a=a||Object.keys(h.current);return F?ia(a):isArray(a)?(a=await Promise.all(a.map(async a=>await aa(a,!0))),y(),a.every(Boolean)):await aa(a)},[ia,aa,y,F]),ja=a=>M.current||D.current.has(a)||D.current.has((a.match(/\w+/)||[])[0]);v.current=v.current?v.current:async({type:a,target:b})=>{b=b?b.name:"";var e=h.current,f=e[b],w=get(n.current,b);if(f){var u=a===EVENTS.BLUR;w=skipValidation({hasError:!!w,isOnChange:S,isBlurEvent:u,isOnSubmit:G,isReValidateOnSubmit:ea,
isOnBlur:J,isReValidateOnBlur:da,isSubmitted:B.current});a=fa(b);a=ja(b)||a;u&&!get(k.current,b)&&H.current.touched&&(set(k.current,b,!0),a=!0);if(w)return a&&y();F?({errors:f}=await validateWithSchema(c,z,getFieldValueByName(e),d,I.current),e=t.current,t.current=isEmptyObject(f),f=get(f,b)?{[b]:get(f,b)}:{},e!==t.current&&(a=!0)):f=await validateField(h,z,f);!U(b,f)&&a&&y()}};let X=useCallback((a={})=>{const b=isEmptyObject(q.current)?getFieldsValues(h.current):q.current;validateWithSchema(c,z,transformToNestObject(Object.assign(Object.assign({},
b),a)),d,I.current).then(({errors:a})=>{const b=t.current;t.current=isEmptyObject(a);b!==t.current&&y()})},[y,z,d]),ca=useCallback((a,b)=>{!isUndefined(v.current)&&a&&findRemovedFieldAndRemoveListener(h.current,v.current,a,b)},[]),W=useCallback((a,b)=>{if(a&&(!a||!isNameInFieldArray(E.current,a.ref.name)||b)){ca(a,b);var {name:c}=a.ref;n.current=unset(n.current,[c]);k.current=unset(k.current,[c]);C.current=unset(C.current,[c]);[p,m,A,D].forEach(a=>a.current.delete(c));if(H.current.isValid||H.current.touched)y(),
F&&X()}},[y,F,X,ca]),ka=({name:a,type:b,types:c,message:d,preventRender:e})=>{const f=h.current[a];isSameError(n.current[a],{type:b,message:d,types:c})||(set(n.current,a,{type:b,types:c,message:d,ref:f?f.ref:{},isManual:!0}),e||y())};b=useCallback(a=>async b=>{b&&(b.preventDefault(),b.persist());let e={},f={};const u=h.current;H.current.isSubmitting&&(O.current=!0,y());try{if(F){f=getFieldsValues(u);const {errors:a,values:b}=await validateWithSchema(c,z,transformToNestObject(f),d,I.current);e=n.current=
a;f=b}else for(const a of Object.values(u))if(a){const {ref:b,ref:{name:c}}=a,d=await validateField(h,z,a);d[c]?(set(e,c,d[c]),A.current.delete(c)):(m.current.has(c)&&A.current.add(c),f[c]=getFieldValue(u,b))}isEmptyObject(e)?(n.current={},await a(transformToNestObject(f),b)):(g&&L&&focusErrorField(u,e),n.current=e)}finally{B.current=!0,O.current=!1,Q.current+=1,y()}},[L,y,F,g,z,d,c]);let la=({errors:a,dirty:b,isSubmitted:c,touched:d,isValid:e,submitCount:f})=>{h.current={};a||(n.current={});d||(k.current=
{});e||(A.current=new Set,m.current=new Set,t.current=!0);b||(p.current=new Set,N.current=!1);c||(B.current=!1);f||(Q.current=0);C.current={};r.current={};D.current=new Set;M.current=!1};useEffect(()=>()=>{K.current=!0;h.current&&"production"===process.env.NODE_ENV&&Object.values(h.current).forEach(a=>W(a,!0))},[W]);F||(t.current=A.current.size>=m.current.size&&isEmptyObject(n.current));e={dirty:N.current,dirtyFields:p.current,isSubmitted:B.current,submitCount:Q.current,touched:k.current,isSubmitting:O.current,
isValid:G?B.current&&isEmptyObject(n.current):t.current};e={triggerValidation:ba,setValue:useCallback(function(a,b,c){let d=!1,e=isArray(a);(e?a:[a]).forEach(a=>{let c=isString(a);d=ha(c?a:Object.keys(a)[0],c?b:Object.values(a)[0])||e?!0:ja(a)});(d||e)&&y();(c||e&&b)&&ba(e?void 0:a)},[y,ha,ba]),register:useCallback(function(a,b){if(!u)if(isString(a))x({name:a},b);else if(isObject(a)&&"name"in a)x(a,b);else return b=>b&&x(b,a)},[q.current,C.current]),unregister:useCallback(function(a){isEmptyObject(h.current)||
(isArray(a)?a:[a]).forEach(a=>W(h.current[a],!0))},[]),getValues:useCallback(a=>{var b=getFieldsValues(h.current);b=isEmptyObject(b)?q.current:b;return a&&a.nest?transformToNestObject(b):b},[]),formState:a?new Proxy(e,{get:(a,b)=>b in a?(H.current[b]=!0,a[b]):{}}):e};a=Object.assign(Object.assign(Object.assign({removeFieldEventListener:ca,reRender:y},F?{validateSchemaIsValid:X}:{}),{mode:{isOnBlur:J,isOnSubmit:G,isOnChange:S},reValidateMode:{isReValidateOnBlur:da,isReValidateOnSubmit:ea},errorsRef:n,
touchedFieldsRef:k,fieldsRef:h,isWatchAllRef:M,watchFieldsRef:D,resetFieldArrayFunctionRef:P,fieldArrayDefaultValues:r,validFieldsRef:A,dirtyFieldsRef:p,fieldsWithValidationRef:m,fieldArrayNamesRef:E,isDirtyRef:N,readFormStateRef:H,defaultValuesRef:q}),e);return Object.assign({watch:function(a,b){let c=isUndefined(b)?isUndefined(q.current)?{}:q.current:b,d=getFieldsValues(h.current,a),e=D.current;isEmptyObject(c)||(H.current.dirty=!0);if(isString(a))return assignWatchFields(d,a,e,c);if(isArray(a))return a.reduce((a,
b)=>Object.assign(Object.assign({},a),{[b]:assignWatchFields(d,b,e,c)}),{});M.current=!0;b=!isEmptyObject(d)&&d||c;return a&&a.nest?transformToNestObject(b):b},control:a,handleSubmit:b,reset:useCallback((a,b={})=>{if(L)for(const a of Object.values(h.current))if(a){const {ref:b,options:c}=a,d=isRadioOrCheckboxFunction(b)&&isArray(c)?c[0].ref:b;if(isHTMLElement(d))try{d.closest("form").reset();break}catch(ma){}}a&&(q.current=a);Object.values(P.current).forEach(a=>isFunction(a)&&a());la(b);y()},[]),
clearError:useCallback(function(a){isUndefined(a)?n.current={}:unset(n.current,isArray(a)?a:[a]);y()},[]),setError:useCallback(function(a,b="",c){isString(a)?ka(Object.assign({name:a},isObject(b)?{types:b,type:""}:{type:b,message:c})):isArray(a)&&(a.forEach(a=>ka(Object.assign(Object.assign({},a),{preventRender:!0}))),y())},[]),errors:n.current},e)}
function __rest(a,b){var c={},d;for(d in a)Object.prototype.hasOwnProperty.call(a,d)&&0>b.indexOf(d)&&(c[d]=a[d]);if(null!=a&&"function"===typeof Object.getOwnPropertySymbols){var e=0;for(d=Object.getOwnPropertySymbols(a);e<d.length;e++)0>b.indexOf(d[e])&&Object.prototype.propertyIsEnumerable.call(a,d[e])&&(c[d[e]]=a[d[e]])}return c}let FormGlobalContext=React.createContext(null);function useFormContext(){return React.useContext(FormGlobalContext)}
function FormContext(a){var {children:b,formState:c,errors:d}=a;a=__rest(a,["children","formState","errors"]);return React.createElement(FormGlobalContext.Provider,{value:Object.assign(Object.assign({},a),{formState:c,errors:d})},b)}var generateId=()=>{let a=typeof performance===UNDEFINED?Date.now():1E3*performance.now();return"xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,function(b){let c=(16*Math.random()+a)%16|0;return("x"==b?c:c&3|8).toString(16)})};
let appendId=(a,b)=>Object.assign({[b]:generateId()},isObject(a)?a:{value:a}),mapIds=(a,b)=>(isArray(a)?a:[]).map(a=>appendId(a,b));var getSortRemovedItems=(a,b,c=[],d=0,e=[])=>{for(let c of b)0>a.indexOf(c)&&e.push(c);for(let f of a.sort())-1<b.indexOf(f)?(c.push(-1),d++):c.push(f-d-(e.length?e.map(a=>a<f).filter(Boolean).length:0));return c};let removeAt=(a,b)=>[...a.slice(0,b),...a.slice(b+1)];
function removeAtIndexes(a,b){let c=-1;for(;++c<a.length;)0<=b.indexOf(c)&&delete a[c];return a.filter(Boolean)}var removeArrayAt=(a,b)=>isUndefined(b)?[]:isArray(b)?removeAtIndexes(a,b):removeAt(a,b),moveArrayAt=(a,b,c)=>isArray(a)?a.splice(c,0,a.splice(b,1)[0]):[],swapArrayAt=(a,b,c)=>{let d=[a[c],a[b]];a[b]=d[0];a[c]=d[1]};function prepend(a,b){return[...isArray(b)?b:[b||null],...a]}function insert(a,b,c){return[...a.slice(0,b),...isArray(c)?c:[c||null],...a.slice(b)]}
var fillEmptyArray=a=>isArray(a)?Array(a.length).fill(null):null;
let {useEffect:useEffect$1,useCallback:useCallback$1,useRef:useRef$1,useState:useState$1}=React,useFieldArray=({control:a,name:b,keyName:c="id"})=>{const d=useFormContext(),{isWatchAllRef:e,resetFieldArrayFunctionRef:f,fieldArrayNamesRef:g,reRender:l,fieldsRef:x,getValues:h,defaultValuesRef:z,removeFieldEventListener:n,errorsRef:k,dirtyFieldsRef:r,isDirtyRef:D,touchedFieldsRef:p,readFormStateRef:m,watchFieldsRef:A,validFieldsRef:t,fieldsWithValidationRef:C,fieldArrayDefaultValues:q,validateSchemaIsValid:K}=
a||d.control,M=useRef$1([...get(q.current[getFieldArrayParentName(b)]?q.current:z.current,b,[])]),[B,N]=useState$1(mapIds(M.current,c)),[Q,O]=useState$1(!1),v=useRef$1(B),P=isKey(b);v.current=B;P&&(q.current[b]=M.current);const I=a=>a.map(a=>appendId(a,c)),E=a=>{N(a);m.current.isValid&&K&&K({[b]:a})},R=({shouldRender:a,isRemove:c,isPrePend:d,index:e,value:f={}}={})=>{f=isArray(f)?f:[f];if(m.current.dirty){a={};if(d||c)for(const c of[...r.current].sort())if(isMatchFieldArrayName(c,b)){var u=c.match(REGEX_ARRAY_FIELD_INDEX);
u&&(u=+u[u.length-1],a[u]?a[u].push(c):a[u]=[c]);r.current.delete(c)}if(!isUndefined(e)||d){const b=isUndefined(e)?[]:getSortRemovedItems(Object.keys(a).map(a=>+a),isArray(e)?e:[e]);Object.values(a).forEach((a,c)=>{c=d?0:b[c];if(-1<c)for(const b of a){const e=b.match(REGEX_ARRAY_FIELD_INDEX);e&&r.current.add(b.replace(/[\d+]([^[\d+]+)$/,`${d?+e[e.length-1]+a.length:c}$1`))}})}c||(f.forEach((a,c)=>Object.keys(a).forEach(a=>r.current.add(`${b}[${d?c:v.current.length+c}].${a}`))),D.current=!0);a=!0}a&&
l()},J=a=>{m.current.dirty&&(D.current=isUndefined(a)?!0:getIsFieldsDifferent(a,z.current[b]||[]));for(const a in x.current)isMatchFieldArrayName(a,b)&&x.current[a]&&n(x.current[a],!0)},G=()=>{const a=get(h({nest:!0}),b);if(isArray(a))for(let b=0;b<a.length;b++)v.current[b]=Object.assign(Object.assign({},v.current[b]),a[b])},S=()=>{J();N(mapIds(M.current,c))};useEffect$1(()=>{P&&Q&&B.length<q.current[b].length&&q.current[b].pop()},[B,b,q,Q,P]);useEffect$1(()=>{if(e&&e.current)l();else if(A)for(const a of A.current)if(a.startsWith(b)){l();
break}},[B,b,l,A,e]);useEffect$1(()=>{const a=f.current,c=g.current;c.add(b);a[b]=S;return()=>{J();delete a[b];c.delete(b)}},[]);return{swap:useCallback$1((a,c)=>{G();const d=getFieldValueByName(x.current,b);swapArrayAt(d,a,c);J(d);swapArrayAt(v.current,a,c);E([...v.current]);k.current[b]&&swapArrayAt(k.current[b],a,c);m.current.touched&&p.current[b]&&(swapArrayAt(p.current[b],a,c),l())},[]),move:useCallback$1((a,c)=>{G();const d=getFieldValueByName(x.current,b);moveArrayAt(d,a,c);J(d);moveArrayAt(v.current,
a,c);E([...v.current]);k.current[b]&&moveArrayAt(k.current[b],a,c);m.current.touched&&p.current[b]&&(moveArrayAt(p.current[b],a,c),l())},[]),prepend:useCallback$1(a=>{let d=!1;J();E(prepend(v.current,isArray(a)?I(a):[appendId(a,c)]));k.current[b]&&(k.current[b]=prepend(k.current[b],fillEmptyArray(a)));m.current.touched&&p.current[b]&&(p.current[b]=prepend(p.current[b],fillEmptyArray(a)),d=!0);R({shouldRender:d,isPrePend:!0,value:a})},[]),append:useCallback$1(a=>{E([...v.current,...isArray(a)?I(a):
[appendId(a,c)]]);R({value:a})},[]),remove:useCallback$1(a=>{var c=!1;const d=isUndefined(a);d||G();J(removeArrayAt(getFieldValueByName(x.current,b),a));E(removeArrayAt(v.current,a));O(!0);k.current[b]&&(k.current[b]=removeArrayAt(k.current[b],a),k.current[b].filter(Boolean).length||delete k.current[b]);m.current.touched&&p.current[b]&&(p.current[b]=removeArrayAt(p.current[b],a),c=!0);if(m.current.isValid&&!K){for(c=-1;c++<B.length;){const e=c===B.length-1,f=0<=(isArray(a)?a:[a]).indexOf(c);if(f||
d)for(const a in B[c]){const g=`${b}[${c}].${a}`;if(f||e||d)t.current.delete(g),C.current.delete(g);else{const d=`${b}[${c-1}].${a}`;t.current.has(g)&&t.current.add(d);C.current.has(g)&&C.current.add(d)}}}c=!0}R({shouldRender:c&&!e.current,isRemove:!0,index:a})},[B]),insert:useCallback$1((a,d)=>{G();J(insert(getFieldValueByName(x.current,b),a));E(insert(v.current,a,isArray(d)?I(d):[appendId(d,c)]));k.current[b]&&(k.current[b]=insert(k.current[b],a,fillEmptyArray(d)));m.current.touched&&p.current[b]&&
(p.current[b]=insert(p.current[b],a,fillEmptyArray(d)),l())},[]),fields:B}};var getInputValue=(a,b)=>isPrimitive(a)||!isObject(a.target)||isObject(a.target)&&!a.type?a:b||isUndefined(a.target.value)?a.target.checked:a.target.value;
let Controller=a=>{var {name:b,rules:c,as:d,onBlur:e,onChange:f,onChangeName:g=VALIDATION_MODE.onChange,onBlurName:l=VALIDATION_MODE.onBlur,valueName:x,defaultValue:h,control:z,onFocus:n}=a;a=__rest(a,"name rules as onBlur onChange onChangeName onBlurName valueName defaultValue control onFocus".split(" "));var k=useFormContext();const {defaultValuesRef:r,setValue:D,register:p,unregister:m,errorsRef:A,removeFieldEventListener:t,triggerValidation:C,mode:{isOnSubmit:q,isOnBlur:K,isOnChange:M},reValidateMode:{isReValidateOnBlur:B,
isReValidateOnSubmit:N},formState:{isSubmitted:Q},fieldsRef:O,fieldArrayNamesRef:v}=z||k.control,[P,I]=React.useState(isUndefined(h)?get(r.current,b):h),E=React.useRef(P),R=isBoolean(P),J=K||B,G=React.useRef(c);G.current=c;const S=()=>!skipValidation({hasError:!!get(A.current,b),isOnBlur:K,isOnSubmit:q,isOnChange:M,isReValidateOnBlur:B,isReValidateOnSubmit:N,isSubmitted:Q}),u=a=>{a=getInputValue(a,R);I(a);return E.current=a};k=a=>(...c)=>D(b,u(a(c)),S());const F=a=>{a=u(a);D(b,a,S())},L=React.useCallback(()=>
{isNameInFieldArray(v.current,b)&&O.current[b]&&t(O.current[b],!0);p(Object.defineProperty({name:b,focus:n},VALUE,{set(a){I(a);E.current=a},get(){return E.current}}),G.current)},[v,O,G,b,n,p,t]);React.useEffect(()=>{const a=v.current;L();return()=>{isNameInFieldArray(a,b)||m(b)}},[b,m,v,L]);React.useEffect(()=>{L()},[L]);O.current[b]||(L(),I(isUndefined(h)?get(r.current,b):h));a=Object.assign(Object.assign(Object.assign(Object.assign({name:b},a),f?{[g]:k(f)}:{[g]:F}),e||J?{[l]:(...a)=>{e&&e(a);J&&
C(b)}}:{}),{[x||(R?"checked":VALUE)]:P});return React.isValidElement(d)?React.cloneElement(d,a):React.createElement(d,a)},ErrorMessage=a=>{var {as:b,errors:c,name:d,message:e,children:f}=a;a=__rest(a,["as","errors","name","message","children"]);var g=useFormContext();g=get(c||g.errors,d);if(!g)return null;const {message:l,types:x}=g;a=Object.assign(Object.assign({},b?a:{}),{children:f?f({message:l||e,messages:x}):l||e});return b?React.isValidElement(b)?React.cloneElement(b,a):React.createElement(b,
a):React.createElement(React.Fragment,Object.assign({},a))};exports.Controller=Controller;exports.ErrorMessage=ErrorMessage;exports.FormContext=FormContext;exports.useFieldArray=useFieldArray;exports.useForm=useForm;exports.useFormContext=useFormContext
